package j2d.filters.bufferedImageConvolution;

import j2d.ImageProcessorInterface;
import j2d.ImageUtils;
import j2d.border.Utils;

import javax.media.jai.PlanarImage;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.awt.image.BufferedImageOp;
import java.awt.image.ConvolveOp;

/**
 * Created by Robert Distinti.
 * User: default
 * Date: Sep 23, 2005
 * Time: 9:06:48 PM
 */
public class FFTR2ImageConvolver implements ImageProcessorInterface {
    private ImageMatrixBean o;
    //todo hw6 you will need to implement this with an FFT2dR2
    public Image process(Image image) {
        BufferedImage bi;
        bi=ImageUtils.getBufferedImage2(image);
        BufferedImageOp op=new ConvolveOp(o.getKernel());

        PlanarImage borderImage = Utils.getBorderImage(ImageUtils.getPlanarImage(bi),
                o.getMatrixSize(),o.getMatrixSize(),o.getMatrixSize(),o.getMatrixSize(),
                o.getBorderType());
        bi=borderImage.getAsBufferedImage();
        return op.filter(bi,null);
    }

    public FFTR2ImageConvolver(ImageMatrixBean o){
        this.o=o;
    }
}

